# Serration Map Code
# Written by Atenfyr

# /scoreboard players set @s giveSword -1
# /execute at @e[type=armor_stand,tag=Foundation] run forceload add ~ ~ ~-15 ~15
# /execute at @e[type=armor_stand,name=serrSpawnpoint] run forceload add ~ ~
# /execute at @e[type=armor_stand,name=serrDeathmatch] run forceload add ~ ~
# /gamerule sendCommandFeedback false

# On join trigger
scoreboard players add @a onJoin 0
execute as @a[scores={onJoin=0},gamemode=!spectator,tag=!playingSerration] at @s run function serration:lobby/on_join

# remove tutorial area tags if escaped without portal
tag @a[gamemode=spectator] remove inTutArea
tag @a[tag=playingSerration] remove inTutArea

# Prevent opening smithing tables and hoppers if it can be helped
scoreboard players remove @a[scores={forceCloseGuiTimer=1..}] forceCloseGuiTimer 1
execute at @a[scores={forceCloseGuiTimer=1}] run fill ~-5 ~-5 ~-5 ~5 ~5 ~5 minecraft:air replace minecraft:nether_portal
execute as @a[scores={openHopper=1..}] at @s run function serration:force_close_gui
execute as @a[scores={openSmithingTable=1..}] at @s run function serration:force_close_gui
scoreboard players set @a openHopper 0
scoreboard players set @a openSmithingTable 0

function serration:360
function serration:passives
function serration:signs

#execute positioned -1168 116 -960 run tag @a[gamemode=spectator,dx=38,dy=6,dz=43] add switchingToAdventure
#execute positioned -1153 117 -965 run tag @a[gamemode=spectator,dx=22,dy=-10,dz=26] add switchingToAdventure
execute as @a[tag=!playingSerration] at @s[gamemode=!spectator] run tag @s[y=255,dy=100] add switchingToAdventure
tp @a[tag=switchingToAdventure] -1142 96 -952
gamemode adventure @a[tag=switchingToAdventure]
tag @a remove switchingToAdventure

# Glyphs
scoreboard players enable @a glyphs
tellraw @a[scores={glyphs=1..}] [{"translate":"serration.game.glyphs","color":"green"},{"text":"\ue000","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.aurelium2","color":"yellow"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue000"}},{"text":" \ue001","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.ferrox2","color":"white"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue001"}},{"text":" \ue002","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.ceranite","color":"#ED7655"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue002"}},{"text":" \ue003","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.fortanium2","color":"red"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue003"}},{"text":" \ue004","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.pearl","color":"green"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue004"}},{"text":" \ue005","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"item.minecraft.dried_kelp","color":"gold"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue005"}},{"text":" \ue006","color":"white","hoverEvent":{"action":"show_text","value":[{"translate":"serration.item.key","color":"gold"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue006"}},{"text":" \ue007","color":"white","hoverEvent":{"action":"show_text","value":[{"text":"Unknown Ingot","color":"white"}]},"clickEvent":{"action":"copy_to_clipboard","value":"\ue007"}}]
scoreboard players set @a[scores={glyphs=1..}] glyphs 0

function serration:endgame
function serration:shrines/quarries
function serration:achievements
function serration:init/map_init_loop

function serration:shrines/forger
function serration:shrines/drill
function serration:shrines/vault
function serration:shrines/bell
function serration:shrines/purity

function serration:environment
function serration:tutorial
function serration:wormhole
function serration:credits

scoreboard players set * onJoin 0
scoreboard players set @a onJoin 1
