# old entrance
execute positioned -1154 101 -948 as @a[dx=-11,dy=-6,dz=7,tag=inParkourArea,gamemode=!spectator] run function serration:parkour/on_exit

# new entrance
execute positioned -1151 98 -953 as @a[dx=2,dy=-4,dz=-3,tag=inParkourArea,gamemode=!spectator] run function serration:parkour/on_exit

# make sure anyone in-game isnt in the parkour
execute as @a[tag=inParkourArea] run tag @s[tag=playingSerration] add nowLeavingParkour

title @a[tag=nowLeavingParkour] actionbar ""
clear @a[tag=nowLeavingParkour]
execute as @a[tag=nowLeavingParkour] run scoreboard players set @s[tag=!playingSerration] serrLoadout 2
execute as @a[tag=nowLeavingParkour] run scoreboard players set @s[tag=playingSerration] serrLoadout 1
tag @a[tag=nowLeavingParkour] add pkResTimer
execute at @a[tag=nowLeavingParkour] as @e[type=armor_stand,name=pkCheckpoint] if score @s serrIntID = @p serrIntID run kill @s
team join none @a[tag=nowLeavingParkour]
tag @a[tag=nowLeavingParkour] remove inParkourArea
tag @a remove nowLeavingParkour

# old entrance
execute positioned -1161 98 -952 as @a[dx=5,dy=-4,dz=-2,tag=!inParkourArea,gamemode=!spectator] run function serration:parkour/on_enter

# new entrance
execute positioned -1153 98 -953 as @a[dx=-2,dy=-4,dz=-3,tag=!inParkourArea,gamemode=!spectator] run function serration:parkour/on_enter

execute as @e[type=armor_stand,name=pkCheckpoint,tag=!allSetup] at @s run scoreboard players operation @s serrIntID = @p serrIntID
tag @e[type=armor_stand,name=pkCheckpoint,tag=!allSetup] add allSetup

tag @a remove isSavingCheckpoint
tag @a remove pkRdyForCheck
scoreboard players add @a[tag=inParkourArea] pkCheckTimer 1
tag @a[tag=inParkourArea,scores={pkCheckTimer=2..}] add pkRdyForCheck
scoreboard players set @a[tag=inParkourArea,scores={pkCheckTimer=2..}] pkCheckTimer 0

execute as @a[tag=pkRdyForCheck] at @s if block ~ ~-1 ~ minecraft:lime_wool run tag @s add isSavingCheckpoint
execute as @a[tag=pkRdyForCheck] at @s if block ~ ~-1 ~ minecraft:lime_concrete_powder run tag @s add isSavingCheckpoint
execute as @a[tag=pkRdyForCheck] at @s if block ~ ~ ~ minecraft:green_carpet run tag @s remove isSavingCheckpoint

execute at @a[tag=isSavingCheckpoint] as @e[type=armor_stand,name=pkCheckpoint] if score @s serrIntID = @p serrIntID run tp @s @p

tag @a remove pkFailed
execute as @a[tag=inParkourArea] at @s if block ~ ~ ~ minecraft:green_carpet run tag @s add pkFailed
execute at @a[tag=pkFailed] as @e[type=armor_stand,name=pkCheckpoint] if score @s serrIntID = @p serrIntID run tp @p @s
execute as @a[tag=pkFailed] at @s run playsound minecraft:entity.enderman.teleport master @a[distance=..50] ~ ~ ~ 0.65 1.25

tp @a[tag=pkCancel] -1160 96 -958 67 -22.5
tag @a remove pkCancel

scoreboard players add @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}}] serrIntID 0
execute as @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}},scores={serrIntID=0}] at @s run scoreboard players operation @s serrIntID = @p[tag=inParkourArea] serrIntID
execute at @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}}] run tag @p[tag=inParkourArea] add pkCancel
execute at @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}}] run tag @p[tag=inParkourArea] add pkResTimer
execute as @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}}] at @a[tag=inParkourArea] if score @s serrIntID = @p serrIntID run tp @s @p
execute as @e[type=item,nbt={Item:{tag:{IsParkourStick:1b}}}] run data merge entity @s {PickupDelay:0s}

scoreboard players enable @a[tag=inParkourArea] stuck
execute as @a[tag=inParkourArea,scores={stuck=1..}] run tag @s[tag=!playingSerration] add pkCancel
execute as @a[tag=inParkourArea,scores={stuck=1..}] run tag @s[tag=!playingSerration] add pkResTimer
scoreboard players set @a[scores={stuck=1..}] stuck 0

# Timer
scoreboard players add @a pkPbRaw 0
tag @a remove brokePB
effect give @a[tag=inParkourArea] minecraft:resistance 2 4 true
effect give @a[tag=inParkourArea] minecraft:water_breathing 2 0 true
effect give @a[tag=inParkourArea] minecraft:instant_health 40 4 true
tag @a remove startingPk
execute as @a[tag=inParkourArea] at @s if block ~ ~-1 ~ minecraft:white_wool run tag @s[tag=!pkTiming] add startingPk
execute as @a[tag=inParkourArea,scores={onRiptide=1..}] run tag @s[tag=!pkTiming] add startingPk
scoreboard players set @a[tag=startingPk] pkRawTimer 0
tag @a[tag=startingPk] add pkTiming
tag @a[tag=startingPk] remove pkDQ
scoreboard players set @a[scores={onRiptide=1..}] onRiptide 0

execute as @a[tag=pkTiming] run function serration:parkour/on_timer_tick

execute as @a[tag=finishedParkour,limit=1] at @s[tag=pkTiming] run function serration:parkour/on_finished
tag @a[tag=finishedParkour] remove pkTiming
tag @a remove finishedParkour

scoreboard players set @a[tag=pkResTimer] pkRawTimer 0
execute as @a[tag=pkResTimer] run title @s actionbar ""
tag @a[tag=pkResTimer] remove pkDQ
tag @a[tag=pkResTimer] remove pkTiming
tag @a[tag=pkResTimer] remove pkResTimer

# Ending
tag @a[x=-1126,y=80,z=-894,dx=2,dy=4,dz=2] add finishedParkour

# Gyroscope mod parkour easter egg
execute positioned -1137 141 -984 if block ~ ~ ~ #minecraft:buttons[powered=true] run loot spawn ~ ~ ~ loot serration:mod360
execute positioned -1137 141 -984 if block ~ ~ ~ #minecraft:buttons[powered=true] run setblock ~ ~ ~ minecraft:polished_blackstone_button[face=ceiling,facing=north,powered=false]
fill -1139 141 -985 -1136 138 -985 minecraft:warped_fence_gate[facing=north,in_wall=false,open=true,powered=false]

# Keep that one trapdoor flat unless someone's nearby
execute positioned -1161 139 -977 if block ~ ~ ~ #minecraft:trapdoors[open=true] unless entity @a[distance=..5] run playsound minecraft:block.wooden_trapdoor.close block @a ~ ~ ~ 1 1
execute positioned -1161 139 -977 if block ~ ~ ~ #minecraft:trapdoors[open=true] unless entity @a[distance=..5] run setblock ~ ~ ~ minecraft:oak_trapdoor[facing=north,half=bottom,open=false]
